
/*  A Bison parser, made from dfilter-grammar.y
 by  GNU Bison version 1.27
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse dfilter_parse
#define yylex dfilter_lex
#define yyerror dfilter_error
#define yylval dfilter_lval
#define yychar dfilter_char
#define yydebug dfilter_debug
#define yynerrs dfilter_nerrs
#define	T_FT_UINT8	257
#define	T_FT_UINT16	258
#define	T_FT_UINT32	259
#define	T_FT_ETHER	260
#define	T_FT_IPv4	261
#define	T_FT_NONE	262
#define	T_FT_BYTES	263
#define	T_FT_BOOLEAN	264
#define	T_FT_STRING	265
#define	T_FT_IPXNET	266
#define	T_VAL_UNQUOTED_STRING	267
#define	T_VAL_BYTE_STRING	268
#define	T_VAL_NUMBER_STRING	269
#define	T_VAL_BYTE_RANGE	270
#define	TOK_AND	271
#define	TOK_OR	272
#define	TOK_NOT	273
#define	TOK_XOR	274
#define	TOK_EQ	275
#define	TOK_NE	276
#define	TOK_GT	277
#define	TOK_GE	278
#define	TOK_LT	279
#define	TOK_LE	280
#define	TOK_TRUE	281
#define	TOK_FALSE	282

#line 1 "dfilter-grammar.y"


/* dfilter-grammar.y
 * Parser for display filters
 *
 * $Id: dfilter-grammar.y,v 1.17 1999/08/29 04:06:42 gram Exp $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@zing.org>
 * Copyright 1998 Gerald Combs
 *
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#ifdef HAVE_NETINET_IN_H
# include <netinet/in.h>
#endif

#ifdef NEED_SNPRINTF_H
# ifdef HAVE_STDARG_H
#  include <stdarg.h>
# else
#  include <varargs.h>
# endif
# include "snprintf.h"
#endif

#ifndef __GLIB_H__
#include <glib.h>
#endif

#include <string.h>

#ifndef _STDLIB_H
#include <stdlib.h>
#endif

#ifndef __PROTO_H__
#include "proto.h"
#endif

#ifndef __PACKET_H__
#include "packet.h"
#endif

#ifndef __DFILTER_H__
#include "dfilter.h"
#endif

#include "dfilter-int.h"

#ifndef __RESOLV_H__
#include "resolv.h"
#endif

static GNode* dfilter_mknode_join(GNode *n1, enum node_type ntype, int operand, GNode *n2);
static GNode* dfilter_mknode_unary(int operand, GNode *n2);
static GNode* dfilter_mknode_numeric_variable(gint id);
static GNode* dfilter_mknode_numeric_value(guint32 val);
static GNode* dfilter_mknode_ether_value(gchar*);
static GNode* dfilter_mknode_ether_variable(gint id);
static GNode* dfilter_mknode_ipxnet_value(guint32);
static GNode* dfilter_mknode_ipxnet_variable(gint id);
static GNode* dfilter_mknode_ipv4_value(char *host);
static GNode* dfilter_mknode_ipv4_variable(gint id);
static GNode* dfilter_mknode_existence(gint id);
static GNode* dfilter_mknode_bytes_value(GByteArray *barray);
static GNode* dfilter_mknode_bytes_variable(gint id, gint offset, guint length);

static guint32 string_to_value(char *s);
static int ether_str_to_guint8_array(const char *s, guint8 *mac);

/* This is the dfilter we're currently processing. It's how
 * dfilter_compile communicates with us.
 */
dfilter *global_df = NULL;;

/* list of GNodes allocated during parsing. If the parsing fails, we'll
 * use this list to free all the GNodes. If the parsing succeeds, we'll
 * just clear this list since dfilter_clear_filter() will take care of
 * freeing the GNodes when they're no longer needed.
 */
GSList *gnode_slist = NULL;


#line 108 "dfilter-grammar.y"
typedef union {
	gint		operand;	/* logical, relation, alternation */
	gint		variable;
	GNode*		node;
	gchar*		string;
	struct {
		gint	offset;
		guint	length;
	} byte_range;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		80
#define	YYFLAG		-32768
#define	YYNTBASE	31

#define YYTRANSLATE(x) ((unsigned)(x) <= 282 ? yytranslate[x] : 49)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    29,
    30,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     7,    11,    15,    19,    22,    24,    26,
    30,    34,    38,    42,    46,    50,    54,    58,    62,    66,
    68,    70,    72,    74,    76,    78,    80,    82,    84,    86,
    88,    90,    92,    95,    97,    99,   101,   103,   105,   107,
   109,   111,   113,   115,   117,   119,   121,   123,   125,   127,
   129,   131,   133,   135,   137
};

static const short yyrhs[] = {    32,
     0,     0,    29,    32,    30,     0,    32,    17,    32,     0,
    32,    18,    32,     0,    32,    20,    32,     0,    19,    32,
     0,    33,     0,    43,     0,    39,    46,    34,     0,    39,
    46,    39,     0,    40,    47,    35,     0,    40,    47,    40,
     0,    41,    47,    36,     0,    41,    47,    41,     0,    42,
    46,    37,     0,    42,    46,    42,     0,    44,    48,    38,
     0,    44,    48,    44,     0,    15,     0,    14,     0,    15,
     0,    13,     0,    14,     0,    14,     0,     3,     0,     4,
     0,     5,     0,     6,     0,    12,     0,     7,     0,    45,
     0,    45,    16,     0,     3,     0,     4,     0,     5,     0,
     6,     0,     7,     0,    12,     0,     8,     0,     9,     0,
    10,     0,    11,     0,    21,     0,    22,     0,    23,     0,
    24,     0,    25,     0,    26,     0,    21,     0,    22,     0,
    21,     0,    22,     0,    23,     0,    25,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   160,   164,   167,   168,   169,   170,   171,   172,   173,   176,
   180,   185,   189,   194,   198,   204,   208,   213,   217,   225,
   232,   242,   249,   255,   262,   274,   275,   276,   279,   282,
   285,   288,   291,   297,   298,   299,   300,   301,   302,   303,
   304,   305,   306,   309,   310,   311,   312,   313,   314,   317,
   318,   321,   322,   323,   324
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","T_FT_UINT8",
"T_FT_UINT16","T_FT_UINT32","T_FT_ETHER","T_FT_IPv4","T_FT_NONE","T_FT_BYTES",
"T_FT_BOOLEAN","T_FT_STRING","T_FT_IPXNET","T_VAL_UNQUOTED_STRING","T_VAL_BYTE_STRING",
"T_VAL_NUMBER_STRING","T_VAL_BYTE_RANGE","TOK_AND","TOK_OR","TOK_NOT","TOK_XOR",
"TOK_EQ","TOK_NE","TOK_GT","TOK_GE","TOK_LT","TOK_LE","TOK_TRUE","TOK_FALSE",
"'('","')'","statement","expression","relation","numeric_value","ether_value",
"ipxnet_value","ipv4_value","bytes_value","numeric_variable","ether_variable",
"ipxnet_variable","ipv4_variable","variable_name","bytes_variable","any_variable_type",
"numeric_relation","equality_relation","bytes_relation", NULL
};
#endif

static const short yyr1[] = {     0,
    31,    31,    32,    32,    32,    32,    32,    32,    32,    33,
    33,    33,    33,    33,    33,    33,    33,    33,    33,    34,
    35,    36,    37,    37,    38,    39,    39,    39,    40,    41,
    42,    43,    44,    45,    45,    45,    45,    45,    45,    45,
    45,    45,    45,    46,    46,    46,    46,    46,    46,    47,
    47,    48,    48,    48,    48
};

static const short yyr2[] = {     0,
     1,     0,     3,     3,     3,     3,     2,     1,     1,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1
};

static const short yydefact[] = {     2,
    26,    27,    28,    37,    31,    40,    41,    42,    43,    39,
     0,     0,     1,     8,     0,     0,     0,     0,     9,     0,
    32,     7,     0,     0,     0,     0,    44,    45,    46,    47,
    48,    49,     0,    50,    51,     0,     0,     0,    52,    53,
    54,    55,     0,    33,     3,     4,     5,     6,    26,    27,
    28,    20,    10,    11,    29,    21,    12,    13,    30,    22,
    14,    15,    31,    23,    24,    16,    17,    34,    35,    36,
    37,    38,    39,    25,    18,    19,     0,     0,     0,     0
};

static const short yydefgoto[] = {    78,
    13,    14,    53,    57,    61,    66,    75,    15,    16,    17,
    18,    19,    20,    21,    33,    36,    43
};

static const short yypact[] = {    54,
     0,     5,    11,    12,    26,-32768,-32768,-32768,-32768,    58,
    54,    54,    35,-32768,    46,    60,    60,    46,-32768,    53,
   -13,-32768,   -16,    54,    54,    54,-32768,-32768,-32768,-32768,
-32768,-32768,     4,-32768,-32768,    18,    33,    -1,-32768,-32768,
-32768,-32768,    81,-32768,-32768,    20,   -10,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -13,    15,    39,-32768
};

static const short yypgoto[] = {-32768,
    25,-32768,-32768,-32768,-32768,-32768,-32768,    14,    41,    17,
    56,-32768,    55,    57,    78,    80,-32768
};


#define	YYLAST		100


static const short yytable[] = {   -34,
    24,    25,    44,    26,   -35,    63,    49,    50,    51,    26,
   -36,    64,    65,    45,    79,   -34,   -34,   -34,    52,   -34,
   -35,   -35,   -35,    55,   -35,   -38,   -36,   -36,   -36,   -34,
   -36,    56,   -29,   -29,   -35,    22,    23,    25,    80,    26,
   -36,   -38,   -38,   -38,    59,   -38,    54,    60,    46,    47,
    48,    24,    25,    62,    26,   -38,     1,     2,     3,     4,
     5,     6,     7,     8,     9,    10,    27,    28,    29,    30,
    31,    32,    11,    39,    40,    41,    58,    42,   -30,   -30,
    34,    35,    12,    68,    69,    70,    71,    72,     6,     7,
     8,     9,    73,    67,    74,    38,    37,    76,     0,    77
};

static const short yycheck[] = {     0,
    17,    18,    16,    20,     0,     7,     3,     4,     5,    20,
     0,    13,    14,    30,     0,    16,    17,    18,    15,    20,
    16,    17,    18,     6,    20,     0,    16,    17,    18,    30,
    20,    14,    21,    22,    30,    11,    12,    18,     0,    20,
    30,    16,    17,    18,    12,    20,    33,    15,    24,    25,
    26,    17,    18,    37,    20,    30,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    21,    22,    23,    24,
    25,    26,    19,    21,    22,    23,    36,    25,    21,    22,
    21,    22,    29,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    38,    14,    18,    17,    43,    -1,    43
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.27.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 216 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 161 "dfilter-grammar.y"
{
			global_df->dftree = yyvsp[0].node;
		;
    break;}
case 2:
#line 164 "dfilter-grammar.y"
{ global_df->dftree = NULL; ;
    break;}
case 3:
#line 167 "dfilter-grammar.y"
{ yyval.node = yyvsp[-1].node; ;
    break;}
case 4:
#line 168 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_join(yyvsp[-2].node, logical, yyvsp[-1].operand, yyvsp[0].node); ;
    break;}
case 5:
#line 169 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_join(yyvsp[-2].node, logical, yyvsp[-1].operand, yyvsp[0].node); ;
    break;}
case 6:
#line 170 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_join(yyvsp[-2].node, logical, yyvsp[-1].operand, yyvsp[0].node); ;
    break;}
case 7:
#line 171 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_unary(TOK_NOT, yyvsp[0].node); ;
    break;}
case 8:
#line 172 "dfilter-grammar.y"
{ yyval.node = yyvsp[0].node; ;
    break;}
case 9:
#line 173 "dfilter-grammar.y"
{ yyval.node = yyvsp[0].node; ;
    break;}
case 10:
#line 177 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 11:
#line 181 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 12:
#line 186 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 13:
#line 190 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 14:
#line 195 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 15:
#line 199 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 16:
#line 205 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 17:
#line 209 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 18:
#line 214 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 19:
#line 218 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_join(yyvsp[-2].node, relation, yyvsp[-1].operand, yyvsp[0].node);
		;
    break;}
case 20:
#line 226 "dfilter-grammar.y"
{
		yyval.node = dfilter_mknode_numeric_value(string_to_value(yyvsp[0].string));
		g_free(yyvsp[0].string);
	 ;
    break;}
case 21:
#line 233 "dfilter-grammar.y"
{
		yyval.node = dfilter_mknode_ether_value(yyvsp[0].string);
		g_free(yyvsp[0].string);
		if (yyval.node == NULL) {
			YYERROR;
		}
	;
    break;}
case 22:
#line 243 "dfilter-grammar.y"
{
		yyval.node = dfilter_mknode_ipxnet_value(string_to_value(yyvsp[0].string));
		g_free(yyvsp[0].string);
	;
    break;}
case 23:
#line 250 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_ipv4_value(yyvsp[0].string);
			g_free(yyvsp[0].string);
		;
    break;}
case 24:
#line 256 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_ipv4_value(yyvsp[0].string);
			g_free(yyvsp[0].string);
		;
    break;}
case 25:
#line 263 "dfilter-grammar.y"
{
		GByteArray	*barray;

		/* the next function appends to list_of_byte_arrays for me */
		barray = byte_str_to_guint8_array(yyvsp[0].string);
		yyval.node = dfilter_mknode_bytes_value(barray);
		g_free(yyvsp[0].string);
	;
    break;}
case 26:
#line 274 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_numeric_variable(yyvsp[0].variable); ;
    break;}
case 27:
#line 275 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_numeric_variable(yyvsp[0].variable); ;
    break;}
case 28:
#line 276 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_numeric_variable(yyvsp[0].variable); ;
    break;}
case 29:
#line 279 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_ether_variable(yyvsp[0].variable); ;
    break;}
case 30:
#line 282 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_ipxnet_variable(yyvsp[0].variable); ;
    break;}
case 31:
#line 285 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_ipv4_variable(yyvsp[0].variable); ;
    break;}
case 32:
#line 288 "dfilter-grammar.y"
{ yyval.node = dfilter_mknode_existence(yyvsp[0].variable); ;
    break;}
case 33:
#line 292 "dfilter-grammar.y"
{
			yyval.node = dfilter_mknode_bytes_variable(yyvsp[-1].variable, yyvsp[0].byte_range.offset, yyvsp[0].byte_range.length);
		;
    break;}
case 34:
#line 297 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 35:
#line 298 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 36:
#line 299 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 37:
#line 300 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 38:
#line 301 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 39:
#line 302 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 40:
#line 303 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 41:
#line 304 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 42:
#line 305 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 43:
#line 306 "dfilter-grammar.y"
{ yyval.variable = yyvsp[0].variable; ;
    break;}
case 44:
#line 309 "dfilter-grammar.y"
{ yyval.operand = TOK_EQ; ;
    break;}
case 45:
#line 310 "dfilter-grammar.y"
{ yyval.operand = TOK_NE; ;
    break;}
case 46:
#line 311 "dfilter-grammar.y"
{ yyval.operand = TOK_GT; ;
    break;}
case 47:
#line 312 "dfilter-grammar.y"
{ yyval.operand = TOK_GE; ;
    break;}
case 48:
#line 313 "dfilter-grammar.y"
{ yyval.operand = TOK_LT; ;
    break;}
case 49:
#line 314 "dfilter-grammar.y"
{ yyval.operand = TOK_LE; ;
    break;}
case 50:
#line 317 "dfilter-grammar.y"
{ yyval.operand = TOK_EQ; ;
    break;}
case 51:
#line 318 "dfilter-grammar.y"
{ yyval.operand = TOK_NE; ;
    break;}
case 52:
#line 321 "dfilter-grammar.y"
{ yyval.operand = TOK_EQ; ;
    break;}
case 53:
#line 322 "dfilter-grammar.y"
{ yyval.operand = TOK_NE; ;
    break;}
case 54:
#line 323 "dfilter-grammar.y"
{ yyval.operand = TOK_GT; ;
    break;}
case 55:
#line 324 "dfilter-grammar.y"
{ yyval.operand = TOK_LT; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 542 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 327 "dfilter-grammar.y"


static GNode*
dfilter_mknode_join(GNode *n1, enum node_type ntype, int operand, GNode *n2)
{
	dfilter_node	*node_root;
	GNode		*gnode_root;

	node_root = g_mem_chunk_alloc(global_df->node_memchunk);
	node_root->ntype = ntype;
	node_root->elem_size = 0;
	node_root->fill_array_func = NULL;
	node_root->check_relation_func = NULL;
	if (ntype == relation) {
		node_root->value.relation = operand;
	}
	else if (ntype == logical) {
		node_root->value.logical = operand;
	}
	else {
		g_assert_not_reached();
	}

	gnode_root = g_node_new(node_root);
	g_node_append(gnode_root, n1);
	g_node_append(gnode_root, n2);

	gnode_slist = g_slist_append(gnode_slist, gnode_root);
	return gnode_root;
}

static GNode*
dfilter_mknode_unary(int operand, GNode *n2)
{
	dfilter_node	*node_root;
	GNode		*gnode_root;

	node_root = g_mem_chunk_alloc(global_df->node_memchunk);
	node_root->ntype = logical;
	node_root->value.logical = operand;
	node_root->elem_size = 0;
	node_root->fill_array_func = NULL;
	node_root->check_relation_func = NULL;

	gnode_root = g_node_new(node_root);
	g_node_append(gnode_root, n2);

	gnode_slist = g_slist_append(gnode_slist, gnode_root);
	return gnode_root;
}


static GNode*
dfilter_mknode_numeric_variable(gint id)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = variable;
	node->elem_size = sizeof(guint32);
	node->fill_array_func = fill_array_numeric_variable;
	node->check_relation_func = check_relation_numeric;
	node->value.variable = id;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static GNode*
dfilter_mknode_ether_variable(gint id)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = variable;
	node->elem_size = sizeof(guint8) * 6;
	node->fill_array_func = fill_array_ether_variable;
	node->check_relation_func = check_relation_ether;
	node->value.variable = id;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static GNode*
dfilter_mknode_ipxnet_variable(gint id)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = variable;
	node->elem_size = sizeof(guint8) * 4;
	node->fill_array_func = fill_array_numeric_variable; /* cheating ! */
	node->check_relation_func = check_relation_numeric; /* cheating ! */
	node->value.variable = id;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static GNode*
dfilter_mknode_ipv4_variable(gint id)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = variable;
	node->elem_size = sizeof(guint32);
	node->fill_array_func = fill_array_numeric_variable; /* cheating ! */
	node->check_relation_func = check_relation_numeric; /* cheating ! */
	node->value.variable = id;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static GNode*
dfilter_mknode_bytes_variable(gint id, gint offset, guint length)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = variable;
	node->elem_size = sizeof(GByteArray*);
	node->fill_array_func = fill_array_bytes_variable;
	node->check_relation_func = check_relation_bytes;
	node->value.variable = id;
	node->offset = offset;
	node->length = length;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static GNode*
dfilter_mknode_numeric_value(guint32 val)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = numeric;
	node->elem_size = sizeof(guint32);
	node->fill_array_func = fill_array_numeric_value;
	node->check_relation_func = check_relation_numeric;
	node->value.numeric = val;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

/* Returns NULL on bad parse of ETHER value */
static GNode*
dfilter_mknode_ether_value(gchar *byte_string)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = ether;
	node->elem_size = sizeof(guint8) * 6;
	node->fill_array_func = fill_array_ether_value;
	node->check_relation_func = check_relation_ether;

	if (!ether_str_to_guint8_array(byte_string, &node->value.ether[0])) {
		/* Rather than free the mem_chunk allocation, let it
		 * stay. It will be cleaned up in the next call to
		 * dfilter_clear() */
		dfilter_error_msg = &dfilter_error_msg_buf[0];
		snprintf(dfilter_error_msg, sizeof(dfilter_error_msg_buf),
			"\"%s\" is not a valid hardware address.", byte_string);
		return NULL;
	}

	gnode = g_node_new(node);
	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static GNode*
dfilter_mknode_ipxnet_value(guint32 ipx_net_val)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = ipxnet;
	node->elem_size = sizeof(guint8) * 4;
	node->fill_array_func = fill_array_numeric_value; /* cheating ! */
	node->check_relation_func = check_relation_numeric; /* cheating ! */
	node->value.numeric = ipx_net_val;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static GNode*
dfilter_mknode_ipv4_value(char *host)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = numeric;
	node->elem_size = sizeof(guint32);
	node->fill_array_func = fill_array_numeric_value; /* cheating ! */
	node->check_relation_func = check_relation_numeric; /* cheating ! */
	node->value.numeric = get_host_ipaddr(host);
	node->value.numeric = htonl(node->value.numeric);
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static GNode*
dfilter_mknode_bytes_value(GByteArray *barray)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = bytes;
	node->elem_size = sizeof(GByteArray*);
	node->fill_array_func = fill_array_bytes_value;
	node->check_relation_func = check_relation_bytes;
	node->value.bytes = barray;
	node->offset = G_MAXINT;
	node->length = barray->len;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

static guint32
string_to_value(char *s)
{
	char	*endptr;
	guint32	val;

	val = strtoul(s, &endptr, 0);
	/* I should probably check errno here */

	return (guint32)val;
}
	
static GNode*
dfilter_mknode_existence(gint id)
{
	dfilter_node	*node;
	GNode		*gnode;

	node = g_mem_chunk_alloc(global_df->node_memchunk);
	node->ntype = existence;
	node->elem_size = sizeof(guint32);
	node->fill_array_func = NULL;
	node->check_relation_func = NULL;
	node->value.variable = id;
	gnode = g_node_new(node);

	gnode_slist = g_slist_append(gnode_slist, gnode);
	return gnode;
}

/* converts a string representing an ether HW address
 * to a guint8 array.
 *
 * Returns 0 on failure, 1 on success.
 */
static int
ether_str_to_guint8_array(const char *s, guint8 *mac)
{
	char	ether_str[18]; /* 2+1+2+1+2+1+2+1+2+1+2 + 1 */
	char	*p, *str;
	int	i = 0;

	if (strlen(s) > 17) {
		return 0;
	}
	strcpy(ether_str, s); /* local copy of string */
	str = ether_str;
	while ((p = strtok(str, "-:."))) {
		/* catch short strings with too many hex bytes: 0.0.0.0.0.0.0 */
		if (i > 5) {
			return 0;
		}
		mac[i] = (guint8) strtoul(p, NULL, 16);
		i++;
		/* subsequent calls to strtok() require NULL as arg 1 */
		str = NULL;
	}
	if (i != 6)
		return 0;	/* failed to read 6 hex pairs */
	else
		return 1;	/* read exactly 6 hex pairs */
}

