"""

START Class
  Whole buttload of functions.

# Thu Mar 18 12:45:33 1999
# Release 0.8.1 -- johnchia@innocent.com

"""


from commands import getoutput
from string import split,join,find,replace


# --
# Choose your server..
#
from start_ppp import *
# from mstart_ppp import *

pppctl = pppctlClass()


class startClass:

	def __init__(self,mode = 0):


		self.data_dir	= "../data/"
		self.conf	= self.parse_conf( self.data_dir + "start.conf" )

		if self.conf.has_key('data_dir'): self.data_dir = self.conf[ 'data_dir' ]
		if self.conf.has_key('start_location'): self.start_location = self.conf[ 'start_location' ]
		else: self.start_location = "/"

		if not mode:
			self.mode_bit	= self.conf['default_mode']
		else:
			self.mode_bit	= mode

		self.mode_bits 		= self.conf['mode_bits']
		self.mode_labels	= self.conf['mode_labels']


		self.title	= self.conf['title']
		self.motd	= "<P>" + open(self.data_dir + "start.motd","r").read() + "</P>"

		self.head	= open(self.data_dir + "start.head","r").read()
		self.body	= open(self.data_dir + "start.body","r").read()
		self.foot	= open(self.data_dir + "start.foot","r").read()

		self.pickle_file	= self.data_dir + 'start.pickle'

		if ( self.conf['enable_stats'] & self.mode_bit ) and ( self.conf['enable_uptime_hi'] & self.mode_bit ):
			self.uptime_hi	= int( open(self.data_dir + "start.uptime_hi", "r").read() )

		if self.conf['enable_links'] & self.mode_bit:
			self.links	= split( open(self.data_dir + "start.links","r").read() , "\n" )

		if self.conf['enable_search'] & self.mode_bit:
			self.search	= split( open(self.data_dir + "start.search","r").read() , "<!-- SEP -->\n" )


		self.modes_mark		= "<!-- #*# MODES #*# -->"
		self.title_mark		= "<!-- #*# TITLE #*# -->"

		self.stats_mark		= "<!-- #*# STATS #*# -->"
		self.motd_mark 		= "<!-- #*# MOTD #*# -->"
		self.popcheck_mark	= "<!-- #*# POPCHECK #*# -->"

		self.pppctl_mark	= "<!-- #*# PPPCTL #*# -->"
		self.links_mark		= "<!-- #*# LINKS #*# -->"
		self.search_mark	= "<!-- #*# SEARCH #*# -->"

		self.slashdot_mark	= "<!-- #*# SLASHDOT #*# -->"
		self.freshmeat_mark	= "<!-- #*# FRESHMEAT #*# -->"

		self.connect()


	# --
	# connects to ppp server thing
	#	This is partly broken. Shouldn't print.. dunt know what it should do HEHE
	def connect(self):
		if not pppctl.open_ppp( self.conf['host'], self.conf['port'], self.conf['passwd'], user = self.conf['user'] ):
			print "<P>Cannot connect to: "+host+":"+str(port)+"</P>"
			print "<P>"+pppctl.err_msg+"</P>"
			sys.exit(0)


	# --
	# disconnect from the ppp server thing
	#
	def disconnect(self):
		pppctl.close_ppp()


	# ---
	# returns a dictionary of:
	#  dict [ varname ] = varvalue
	#
	def parse_conf(self,conf_fn):

		from string import strip
		new_conf = {}

		for x in open( conf_fn, 'r' ).readlines():
			if x[0] == "~":	
			# if [0] == ~ == list variable
				tv = split( x, '=' )

				tv[0] = strip( tv[0][1:] )
				tv[1] = strip( tv[1] )

				new_conf[ tv[0] ] = []

				for x in split( tv[1], ',' ):
					try: new_conf[ tv[0] ].append( int(strip(x)) )
					except ValueError: new_conf[ tv[0] ].append( strip(x) )

			elif x[0] != "#" and x[0] != " " and x[0] != "\n":
			# just one variable
				tv = split( x, '=' )				# split into list of varname, value
				try: new_conf [ strip( tv[0] ) ] = int( strip(tv[1]) )	# try to make an int
				except ValueError: new_conf [ strip( tv[0] ) ] = strip( tv[1] )
										# else put string

		return(new_conf)


	# ---
	# Formats an int (of seconds) into a pretty string Xd Xh Xm Xs
	#
	def sec_to_string(self,uptime):
	# ** Make a string out of Uptime seconds ** #
		days = hours = mins = 0
		while uptime > 60:			# longer than a minute
			if uptime > 3600:			# longer than an hour
				if uptime > 86400:			# longer than a day
					days,uptime = divmod(uptime,86400)
				hours,uptime = divmod(uptime,3600)
			else:
				mins,uptime = divmod(uptime,60)
		secs = uptime
		uptime = 	str(int(days)) + " day(s) " + \
				str(int(hours)) + "h " + \
				str(int(mins)) + "m " + \
				str(int(secs)) + "s"
		return(uptime)


	# ---
	# returns strings of uptime + load average
	#
	def return_stats(self):

		if self.conf['system'] == "bsd":
			kern_info = split ( getoutput ('/sbin/sysctl kern.boottime vm.loadavg'), "\n" )
							# get boottime; i think this is gmt..
							# get loadavg; three floats.

			# --
			# Uptime Calcs.

			boot_time = split( kern_info [0] )
			boot_time = int(boot_time[boot_time.index( 'sec' ) + 2 ][:-1])
							# only interested in seconds since the epoch

			from time import *
			uptime = time() - boot_time	# calculate uptime

			# --
			# Load calcs.

			load_avg = "Load: " + kern_info [1] [find(kern_info[1],'{ ')+2:find(kern_info[1],' }')]

		elif self.conf['system'] == "linux":
			uptime = int( float( split( open( '/proc/uptime','r').read() )[0] ) )
			load_avg = "Load: " + join( split( open('/proc/loadavg','r').read() )[:3] )


		# --
		# Here should go the logging code..

		if (self.conf['enable_uptime_hi'] & self.mode_bit) and uptime > self.uptime_hi:
			self.uptime_hi = uptime
			open( self.data_dir + "start.uptime_hi", "w" ).write( str( int(uptime) ) )

		uptime = self.sec_to_string(uptime)

		return(uptime, load_avg)


	# ---
	# return_popcheck
	#   returns a string of the status of multiple mailboxes defined in start.conf
	def return_popcheck(self):
		from poplib import *
		out = []
		for x in range( len( self.conf['popcheck_users'] ) ):
			try:
				mailbox = POP3( self.conf['popcheck_hosts'][x] )
				mailbox.user( self.conf['popcheck_users'][x] )
				mailbox.pass_( self.conf['popcheck_passwords'][x] )
				m_info = mailbox.stat()
				if m_info[0] == 0:
					out.append( self.conf['popcheck_labels'][x]+": no messages" )
				elif m_info[0] == 1:
					out.append( "<B>" + self.conf['popcheck_labels'][x] + ":</B> " + \
					str( m_info[0] ) + " message (" + str( m_info[1]/1024 ) + "k)" )
				else:
					out.append( "<B>" + self.conf['popcheck_labels'][x] + ":</B> " + \
					str( m_info[0] ) + " messages (" + str( m_info[1]/1024 ) + "k)" )
			except socket.error:
				out.append( self.conf['popcheck_labels'][x]+": connect failed" )
		return( join( out, '; ' ) )


	# ---
	# return_head --Returns the proper head for the current mode
	#
	def return_modes( self ):
		out = "Mode: "
		for x in range( len(self.mode_labels) ):
			if self.mode_bits[x] == self.mode_bit:
				out = out + "<B>"+self.mode_labels[x]+"</B>; "
			else:
				out = out + "<A HREF='"+self.start_location+"?mode=" + str(self.mode_bits[x]) + "'>" + \
				self.mode_labels[x] + "</A>; "
		return(out[:-2])


	# ---
	# return_head --Returns the proper head for the current mode
	#     ( i actually use this again below, changing self.head to self.foot )
	def return_head( self ):

		data = self.head

		# --
		# Place `mandatory' stuff
		data = replace( data, self.title_mark, self.title )
		data = replace( data, self.motd_mark, self.motd )
		data = replace( data, self.modes_mark, self.return_modes() )

		# --
		# place uptime maybe
		if self.conf ['enable_stats'] & self.mode_bit:

			uptime,load = self.return_stats()

			long_stats = "<P>Up: " + uptime + ";"
			if self.conf['enable_uptime_hi'] & self.mode_bit:
				long_stats = long_stats + " (High: " + self.sec_to_string(self.uptime_hi) + ")"
			long_stats = long_stats + " " + load + ".</P>"

			data = replace( data, self.stats_mark, long_stats)

		# --
		# place pop3 status maybe
		if self.conf ['enable_popcheck'] & self.mode_bit:

			data = replace( data, self.popcheck_mark, self.return_popcheck() )

		return(data)


	# ---
	# return_body --Returns the proper body for the current mode
	#
	def return_body( self, extra = 0, force_pppctl = 0 ):

		body = self.body


		# Place pppctl
		if self.conf['enable_pppctl'] & self.mode_bit or force_pppctl:
			body = replace( body, self.pppctl_mark, self.return_form(extra) )
	

		# Place links
		if self.conf['enable_links'] & self.mode_bit:
			tmp = "<P><B>Links</B></P><P>\n"
			for x in self.links:
				if x == "--": tmp = tmp + "</P><P>\n"
				elif x != "": tmp = tmp + "` " + x + "<BR>\n"
			tmp = tmp + "</P>\n"
			body = replace( body, self.links_mark, tmp )


		# Place search engines
		if self.conf['enable_search'] & self.mode_bit:
			tmp = ""
			for x in self.search:
				if x != "": tmp = tmp + "<P>\n" + x + "</P>\n"
			body = replace( body, self.search_mark, tmp )


		# Place slashdot
		if self.conf['enable_slashdot'] & self.mode_bit:

			body = replace( body, self.slashdot_mark, self.return_slashdot() )


		# Place freshmeat
		if self.conf['enable_freshmeat'] & self.mode_bit:

			body = replace( body, self.freshmeat_mark, self.return_freshmeat() )


		return(body)


	# ---
	# return_foot --Returns the proper foot for the current mode
	#
	def return_foot( self ):

		data = self.foot

		# --
		# Place `mandatory' stuff
		data = replace( data, self.title_mark, self.title )
		data = replace( data, self.motd_mark, self.motd )
		data = replace( data, self.modes_mark, self.return_modes() )

		# --
		# place uptime maybe
		if self.conf ['enable_stats'] & self.mode_bit:

			uptime,load = self.return_stats()

			long_stats = "<P>Up: " + uptime + ";"
			if self.conf['enable_uptime_hi'] & self.mode_bit:
				long_stats = long_stats + " (High: " + self.sec_to_string(self.uptime_hi) + ")"
			long_stats = long_stats + " " + load + ".</P>"

			data = replace( data, self.stats_mark, long_stats)

		# --
		# place pop3 status maybe
		if self.conf ['enable_popcheck'] & self.mode_bit:

			data = replace( data, self.popcheck_mark, self.return_popcheck() )

		return(data)

	# ---
	# return_form - This composes our UI
	# returns null, takes one parameter for details..
	#
	def return_form(self,extra = 0):

		out = "<P><TT><FORM METHOD='GET' ACTION='" + self.start_location + "'>\n"
		stat = pppctl.status()
		links = []
		for x in stat: links.append(x[0])
		for x in range(len(stat)):
			# print link label
			out = out   + "<B>" + stat[x][0] \
				    + ":</B> " +stat[x][1]

			if stat[x][1] == "open":
				# Print out link stats
				out = out + self.return_link_stats( stat[x] )

			out = out + "<BR>\n"

		if extra: out = out + "verbosity: " + extra		# extra information if provided

		out = out + "<SELECT NAME='link'>"			# connection selection
		for x in links:
			out = out + "<OPTION>" + x
		out = out + "</SELECT>"

		out = out + "<INPUT TYPE=HIDDEN NAME='verb' VALUE='toggle'>"	+\
			"<INPUT TYPE=SUBMIT VALUE='Toggle Status'>\n"
		out = out + "</FORM></TT></P>"

		return(out)


	# --
	# return_link_stats - prints link uptime, pass it a status list.
	#
	def return_link_stats( self, data ):
		out = " "

		# compose `out'
		if data[6] > 60:
			if data[6] > 3600:
				hrs,sec = divmod( data[6], 3600 )
				min = sec/60
				out = out + str(hrs) + "h" + str(min) + "m "
			else:
				min,sec = divmod( data[6], 60 )
				out = out + str(min)+"m"+str(sec)+"s "
		else:
			out = out + str( data[6] ) + "s "

		# final composure
		out = out + "(" + data[2] + ", " \
			    + data[3] + ", " \
			    + data[4] + ")" 	# throughput: now, avg, peak

		# return
		return(out)


	# --
	# return_freshmeat()
	# returns a string
	def return_freshmeat ( self ):
		last_fetch,data = self.fetch_from_pickle( 'freshmeat', 'files.freshmeat.net', '/freshmeat/recentnews.txt' )
		data = split(data, '\n')

		out = '<TT><P><B>"Fresh Meat"</B></P>\n<P>'

		x = 0

		for x in range(0,len(data)-1,3):
		    out = out + '` <A HREF="' + data[x+2] + '">' + data[x] + '</A><BR>'

		out = out + "<P></TT>"
		return(out)


	# --
	# return_slashdot()
	# returns a string
	def return_slashdot ( self ):
		last_fetch, data = self.fetch_from_pickle( 'slashdot', 'www.slashdot.org', '/ultramode.txt' )
		data = split(data, '%%\n')[1:]
		out = '<TT><P><B>Slashdot "Ultra-Mode"</B></P>\n<P>'
		for x in data:
			a = split(x,"\012")
			if len(a) > 2:
				out = out + '` <A HREF="' + a[1] + '">' + a[0] + '</A><BR>\n'
		out = out + "</P></TT>"
		return(out)


	# --
	# fetch_from_pickle -- tries to get something from start.pickle and/or fetch http
	# 	( used for slashdot, freshmeat etc)
	def fetch_from_pickle( self, entry, host='', host_path='' ):

		from time import time
		the_time = time()

		try: 

			dir( self.pickle )	# if we've already loaded the pickle

		except AttributeError: 

			import cPickle
			try: 
				self.pickle = cPickle.load( open( self.pickle_file, 'r' ) )
			except IOError: 
				self.pickle = {}
				self.pickle[ entry ] = [ the_time, self.fetch( host, host_path ) ]
				cPickle.dump( self.pickle, open( self.pickle_file, 'w' ) )

		try:
			if ( self.pickle[ entry ][ 0 ] + self.conf['cache_expiry_time'] ) < the_time:
				self.pickle[ entry ] = [ the_time, self.fetch( host, host_path ) ]
				import cPickle
				cPickle.dump( self.pickle, open( self.pickle_file, 'w' ) )
			return( self.pickle[ entry ][ 0 ], self.pickle[ entry ][ 1 ] )
		except KeyError:
			import cPickle
			self.pickle[ entry ] = [ the_time, self.fetch( host, host_path ) ]
			cPickle.dump( self.pickle, open( self.pickle_file, 'w' ) )
			return( self.pickle[ entry ][ 0 ], self.pickle[ entry ][ 1 ] )


	# --
	# fetch -- fetches host + path (http)
	#
	def fetch( self, host, path ):
		try: dir( httplib )
		except NameError: import httplib
		h = httplib.HTTP( host )
		h.putrequest( 'GET', path )
		h.putheader('Host', host)
		h.putheader( 'Accept', 'text/html' )
		h.putheader( 'Accept', 'text/plain' )
		h.endheaders()
		errcode, errmsg, headers = h.getreply()
	
		return( h.getfile().read() )

"""
"""
